#include "common.fx"

VS_OUTPUT vertex_shader(float4 input_position : POSITION, 
                        float4 color : COLOR0,
                        float4 color_add : COLOR1,
                        float2 uv: TEXCOORD0) {
    VS_OUTPUT output;
    output.position = mul(input_position, object_to_proj_matrix);
    output.color = color;
    output.color_add = color_add + global_color_add;
    output.uv = uv;
    prep_parallel(output);
    return output;
}

PS_OUTPUT pixel_shader(VS_OUTPUT input) {
    PS_OUTPUT output;

//    float bias = -50000;
//    float4 wrapped = float4(input.uv.x, input.uv.y, bias, bias);

    float4 texture_color = sample_diffuse(input.uv);// tex2D(DiffuseTextureSampler, input.uv);
//    float4 texture_color = tex2D(DiffuseTextureSampler, wrapped);

    float4 white = float4(1, 1, 1, 1);
    output.color = input.color * texture_color + input.color_add;
    output.color = lerp(white, output.color, output.color.w);
    output.color = apply_parallel(output.color, input);

//    output.color = input.color * texture_color;
//    output.color = float4(1, 1, 1, 1);
//    output.color = global_color_add;

#ifdef MRT_REWIND
    output.color2 = rewindable_alpha;
    output.color2.a = output.color.a;
#endif
    return output;
}

technique render {
    pass P0 {
        VertexShader = compile vs_1_1 vertex_shader();
        PixelShader  = compile ps_2_0 pixel_shader();

        AlphaBlendEnable = True;
        SrcBlend = Zero;
        DestBlend = SrcColor;
        AlphaTestEnable = True;

        CullMode = None;
        ZEnable = False;
        ZWriteEnable = False;
    }
}


